package iia.espacesEtats.algorithmes;

import iia.espacesEtats.modeles.Probleme;
import iia.espacesEtats.modeles.Solution;

/**
 * Interface minimale d'un algorithme de rsolution de problme de recherche
 * dans un graphe d'tats
 *
 * @author Philippe Chatalic
 */
public abstract class AlgorithmeRechercheEE {

    // Attributs 
    protected int nbNoeudsDeveloppes;   // Accessible dans les classes drives

    //----------------------------------------------------
    // Constructeurs
    //----------------------------------------------------
    AlgorithmeRechercheEE() {
        nbNoeudsDeveloppes = 0;
    }

    //----------------------------------------------------
    // Accesseurs modifieurs
    //----------------------------------------------------
     /**
     * Renvoie le nombre de noeuds dvelopps par l'algorithme
     *
     * @return le nombre de noeuds dvelopps
     */
    public int getNbNoeudsDeveloppes() {
        return nbNoeudsDeveloppes;
    }
    
     //----------------------------------------------------
    // Mthode(s) abstraite(s)
    //----------------------------------------------------
 
    /**
     * Recherche un chemin solution pour un problme formul en terme de
     * recherche dans un espace d'tats
     *
     * @param p le problme  rsoudre
     * @return une solution du problme
     */
    public abstract Solution chercheSolution(Probleme p);


}
