package iia.espacesEtats.modeles;

import java.util.Collection;

/**
 * L'interface d'un tat est succincte, tout ce dont on a besoin pour un tat
 * est : 
 * - que l'on soit capable de calculer ses successeurs
 * - que l'on puisse l'afficher d'une manire standard pour visualiser un chemin 
 * - et que la fonction equals soit redfinie de manire adquate.
 */
public interface Etat {


    /**
     * @param e l'tat considr
     * @return L'ensemble des tats atteignables  partir de l'tat par un
     * oprateur de changement d'tat L'utilisation d'une Collection permet de
     * choisir librement La classe la mieux adapte en fonction du problme
     */
    public Collection<Etat> successeurs();

    @Override
    public boolean equals(Object obj);

    /**
     * @return Une reprsentation de l'tat sous forme de chane
     */
    @Override
    public String toString();
}
